import groovy.json.StringEscapeUtils
import org.jahia.services.content.JCRContentUtils

if (!renderContext.isPreviewMode()) {
    return;
}
if (!renderContext.mainResource.node.hasPermission("canPersonalizeWithMarketingFactory")) {
    return;
}
if(renderContext.mainResource.template.equals("personas")){
    return;
}

if (renderContext.getRequest().getParameterMap().containsKey("channel")) {
    return;
}

if (renderContext.getRequest().getParameterMap().containsKey("hidePersonaPanel")) {
    return;
}


htmlHeadContent.append("<jahia:resource type=\"css\" key=\"\" path=\"" + renderContext.getRequest().getContextPath() + "/modules/marketing-factory-core/css/marketing-factory/wem-persona-panel-button.css\" />\n");
htmlHeadContent.append("<jahia:resource type=\"css\" key=\"\" path=\"" + renderContext.getRequest().getContextPath() + "/modules/marketing-factory-core/css/marketing-factory/vendor/material-icons.css\" />\n");

pageVariants = null
jsPageVariantsJson = "[]"

if(JCRContentUtils.isNodeType(renderContext.mainResource.node, "wemmix:optimizationTestPage")) {
    pageVariants = JCRContentUtils.getChildrenOfType(renderContext.mainResource.node, "wemnt:pageVariant")
    jsPageVariantsJson = "["
    pageVariants.each {
        jsPageVariantsJson += "{name:\"$it.name\", title:\"${StringEscapeUtils.escapeJavaScript(it.displayableName)}\"}"
        if(it != pageVariants.last()) {
            jsPageVariantsJson += ', '
        }
    }
    jsPageVariantsJson += "]"
}

p = """\
        <script type="text/javascript">
            var DMFPersona = DMFPersona || {};
            DMFPersona.panelOpened = false;
            document.addEventListener("DOMContentLoaded", function(event) {
                var pageVariants = null;
                if(${JCRContentUtils.isNodeType(renderContext.mainResource.node, "wemmix:optimizationTestPage")}) {
                    pageVariants = ${jsPageVariantsJson};
                    pageVariants.push({name:\"\", title: \"${StringEscapeUtils.escapeJavaScript(renderContext.mainResource.node.displayableName)}\"});
                }
                var personasFrame = document.getElementById('personas_panel');

                personasFrame.contentWindow.getPageVariants = function(){
                       return pageVariants;
                }
            });

            /*This function add  or remove the class open to the panel wrapper div to animate it and change the panel picture (expand/collapse)*/
            DMFPersona.toogleClass = function(){
                var panel = document.querySelector('.panel_wrapper');
                panel.classList.toggle('open-panel');
                //Change Panel picture alternatively from expand to collapse
                DMFPersona.panelOpened = !DMFPersona.panelOpened;
                var panelIcon = document.getElementById('panel-icon');
                if(DMFPersona.panelOpened) {
                    panelIcon.innerHTML="keyboard_arrow_right";
                } else {
                    panelIcon.innerHTML="keyboard_arrow_left";
                }
            }
        </script>
        <!-- Sliding Drawer -->
        <div class="panel_wrapper" ng-switch="open">
            <!-- Toggle Drawer (Open button) -->
            <div class="panel_button" style="display: inline;">
                <a class="tst-openPersonaPanel toggle_nav" href="#" onclick="DMFPersona.toogleClass()">
                    <i id="panel-icon" class="material-icons">keyboard_arrow_left</i>
                </a>
            </div>
            <div class="template_wrapper">
                <!-- Iframe with the personas editing template -->
                <iframe id="personas_panel" name="personas_panel" SRC="${renderContext.request.contextPath}${renderContext.getURLGenerator().getBasePreview()}${renderContext.site.path}.personas.html" scrolling="yes" height="100%" width="91%">
                </iframe>
            </div>
        </div>

"""

htmlBodyContent.append(p);
