(function() {
    'use strict';

    angular.module('wemCampaignsApp', ['wemApp', 'wemProfilesApp', 'wemGoalsApp']);
})();

(function() {
    'use strict';

    angular.module('wemCampaignsApp').run(wemCampaignsAppRun);

    wemCampaignsAppRun.$inject = ['$rootScope', '_'];

    function wemCampaignsAppRun($rootScope, _) {
        $rootScope.getCurrentModuleResource = function (resourcePath) {
            return ManagersUtils.getCurrentModuleResource(resourcePath);
        };

        $rootScope.currencies = _.map({
            AED: "United Arab Emirates Dirham",
            AFN: "Afghan Afghani",
            ALL: "Albanian Lek",
            AMD: "Armenian Dram",
            ANG: "Netherlands Antillean Guilder",
            AOA: "Angolan Kwanza",
            ARS: "Argentine Peso",
            AUD: "Australian Dollar",
            AWG: "Aruban Florin",
            AZN: "Azerbaijani Manat",
            BAM: "Bosnia-Herzegovina Convertible Mark",
            BBD: "Barbadian Dollar",
            BDT: "Bangladeshi Taka",
            BGN: "Bulgarian Lev",
            BHD: "Bahraini Dinar",
            BIF: "Burundian Franc",
            BMD: "Bermudan Dollar",
            BND: "Brunei Dollar",
            BOB: "Bolivian Boliviano",
            BRL: "Brazilian Real",
            BSD: "Bahamian Dollar",
            BTC: "Bitcoin",
            BTN: "Bhutanese Ngultrum",
            BWP: "Botswanan Pula",
            BYR: "Belarusian Ruble",
            BZD: "Belize Dollar",
            CAD: "Canadian Dollar",
            CDF: "Congolese Franc",
            CHF: "Swiss Franc",
            CLF: "Chilean Unit of Account (UF)",
            CLP: "Chilean Peso",
            CNY: "Chinese Yuan",
            COP: "Colombian Peso",
            CRC: "Costa Rican Colón",
            CUC: "Cuban Convertible Peso",
            CUP: "Cuban Peso",
            CVE: "Cape Verdean Escudo",
            CZK: "Czech Republic Koruna",
            DJF: "Djiboutian Franc",
            DKK: "Danish Krone",
            DOP: "Dominican Peso",
            DZD: "Algerian Dinar",
            EEK: "Estonian Kroon",
            EGP: "Egyptian Pound",
            ERN: "Eritrean Nakfa",
            ETB: "Ethiopian Birr",
            EUR: "Euro",
            FJD: "Fijian Dollar",
            FKP: "Falkland Islands Pound",
            GBP: "British Pound Sterling",
            GEL: "Georgian Lari",
            GGP: "Guernsey Pound",
            GHS: "Ghanaian Cedi",
            GIP: "Gibraltar Pound",
            GMD: "Gambian Dalasi",
            GNF: "Guinean Franc",
            GTQ: "Guatemalan Quetzal",
            GYD: "Guyanaese Dollar",
            HKD: "Hong Kong Dollar",
            HNL: "Honduran Lempira",
            HRK: "Croatian Kuna",
            HTG: "Haitian Gourde",
            HUF: "Hungarian Forint",
            IDR: "Indonesian Rupiah",
            ILS: "Israeli New Sheqel",
            IMP: "Manx pound",
            INR: "Indian Rupee",
            IQD: "Iraqi Dinar",
            IRR: "Iranian Rial",
            ISK: "Icelandic Króna",
            JEP: "Jersey Pound",
            JMD: "Jamaican Dollar",
            JOD: "Jordanian Dinar",
            JPY: "Japanese Yen",
            KES: "Kenyan Shilling",
            KGS: "Kyrgystani Som",
            KHR: "Cambodian Riel",
            KMF: "Comorian Franc",
            KPW: "North Korean Won",
            KRW: "South Korean Won",
            KWD: "Kuwaiti Dinar",
            KYD: "Cayman Islands Dollar",
            KZT: "Kazakhstani Tenge",
            LAK: "Laotian Kip",
            LBP: "Lebanese Pound",
            LKR: "Sri Lankan Rupee",
            LRD: "Liberian Dollar",
            LSL: "Lesotho Loti",
            LTL: "Lithuanian Litas",
            LVL: "Latvian Lats",
            LYD: "Libyan Dinar",
            MAD: "Moroccan Dirham",
            MDL: "Moldovan Leu",
            MGA: "Malagasy Ariary",
            MKD: "Macedonian Denar",
            MMK: "Myanma Kyat",
            MNT: "Mongolian Tugrik",
            MOP: "Macanese Pataca",
            MRO: "Mauritanian Ouguiya",
            MTL: "Maltese Lira",
            MUR: "Mauritian Rupee",
            MVR: "Maldivian Rufiyaa",
            MWK: "Malawian Kwacha",
            MXN: "Mexican Peso",
            MYR: "Malaysian Ringgit",
            MZN: "Mozambican Metical",
            NAD: "Namibian Dollar",
            NGN: "Nigerian Naira",
            NIO: "Nicaraguan Córdoba",
            NOK: "Norwegian Krone",
            NPR: "Nepalese Rupee",
            NZD: "New Zealand Dollar",
            OMR: "Omani Rial",
            PAB: "Panamanian Balboa",
            PEN: "Peruvian Nuevo Sol",
            PGK: "Papua New Guinean Kina",
            PHP: "Philippine Peso",
            PKR: "Pakistani Rupee",
            PLN: "Polish Zloty",
            PYG: "Paraguayan Guarani",
            QAR: "Qatari Rial",
            RON: "Romanian Leu",
            RSD: "Serbian Dinar",
            RUB: "Russian Ruble",
            RWF: "Rwandan Franc",
            SAR: "Saudi Riyal",
            SBD: "Solomon Islands Dollar",
            SCR: "Seychellois Rupee",
            SDG: "Sudanese Pound",
            SEK: "Swedish Krona",
            SGD: "Singapore Dollar",
            SHP: "Saint Helena Pound",
            SLL: "Sierra Leonean Leone",
            SOS: "Somali Shilling",
            SRD: "Surinamese Dollar",
            STD: "São Tomé and Príncipe Dobra",
            SVC: "Salvadoran Colón",
            SYP: "Syrian Pound",
            SZL: "Swazi Lilangeni",
            THB: "Thai Baht",
            TJS: "Tajikistani Somoni",
            TMT: "Turkmenistani Manat",
            TND: "Tunisian Dinar",
            TOP: "Tongan Paʻanga",
            TRY: "Turkish Lira",
            TTD: "Trinidad and Tobago Dollar",
            TWD: "New Taiwan Dollar",
            TZS: "Tanzanian Shilling",
            UAH: "Ukrainian Hryvnia",
            UGX: "Ugandan Shilling",
            USD: "United States Dollar",
            UYU: "Uruguayan Peso",
            UZS: "Uzbekistan Som",
            VEF: "Venezuelan Bolívar Fuerte",
            VND: "Vietnamese Dong",
            VUV: "Vanuatu Vatu",
            WST: "Samoan Tala",
            XAF: "CFA Franc BEAC",
            XAG: "Silver (troy ounce)",
            XAU: "Gold (troy ounce)",
            XCD: "East Caribbean Dollar",
            XDR: "Special Drawing Rights",
            XOF: "CFA Franc BCEAO",
            XPF: "CFP Franc",
            YER: "Yemeni Rial",
            ZAR: "South African Rand",
            ZMK: "Zambian Kwacha (pre-2013)",
            ZMW: "Zambian Kwacha",
            ZWL: "Zimbabwean Dollar"
        }, function (name, symbol) {
            return {value: symbol, label: "(" + symbol + ") " + name}
        });

        $rootScope.timezones = _.map(moment.tz.names(), function (value) {
            return {label: value}
        });
    }
})();

(function() {
    'use strict';

    angular.module('wemCampaignsApp').controller('CampaignCreateEventModalController', CampaignCreateEventModalController);

    CampaignCreateEventModalController.$inject = ['$scope', '$uibModalInstance', 'currentCampaign', 'i18nService'];

    function CampaignCreateEventModalController($scope, $uibModalInstance, currentCampaign, i18nService) {
        //The new campaign
        $scope.currentCampaign = currentCampaign;

        $scope.campaignEvent = {};
        $scope.campaignEvent.eventDate = new Date();
        $scope.currentText = i18nService.message('serverSettings.manageWem.datepicker.today');
        $scope.closeText = i18nService.message('serverSettings.manageWem.datepicker.close');
        $scope.clearText = i18nService.message('wem.label.clear');

        $scope.datePickerOptions = {
            minDate: $scope.currentCampaign.startDate,
            maxDate: $scope.currentCampaign.endDate
        };

        // Calendar functions
        $scope.open = function ($event, selector) {
            $event.preventDefault();
            $event.stopPropagation();
            if (selector == 'start')
                $scope.startopened = true;
            if (selector == 'end')
                $scope.endopened = true;
        };

        $scope.dateOptions = {
            formatYear: 'yyyy',
            startingDay: 1
        };

        $scope.formats = ['dd-MMMM-yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
        $scope.format = $scope.formats[0];

        //Timepicker functions
        $scope.campaignEvent.startTime = new Date();

        $scope.ok = function () {
            $uibModalInstance.close($scope.campaignEvent);
        };

        $scope.cancel = function () {
            $uibModalInstance.dismiss('cancel');
        };

        $scope.campaignEvent.cost = 0.0;

        $scope.campaignEvent.currency = $scope.currencies[_.findIndex($scope.currencies, {value: currentCampaign.currency})];
        $scope.campaignEvent.timezone = $scope.timezones[_.findIndex($scope.timezones, {label: currentCampaign.timezone})];
    }
})();

(function() {
    'use strict';

    angular.module('wemCampaignsApp').controller('CampaignEditController', CampaignEditController);

    CampaignEditController.$inject = ['$scope', '$location', 'unomiCampaignService', '$route', 'currentCampaign', 'isNew', 'i18nService'];

    function CampaignEditController($scope, $location, unomiCampaignService, $route, currentCampaign, isNew, i18nService) {
        $scope.currentCampaign = currentCampaign;
        $scope.isNew = isNew;

        $scope.dateOptions = {
            formatYear: 'yyyy',
            startingDay: 1
        };

        $scope.currentText = i18nService.message('serverSettings.manageWem.datepicker.today');
        $scope.closeText = i18nService.message('serverSettings.manageWem.datepicker.close');
        $scope.clearText = i18nService.message('wem.label.clear');

        $scope.format = 'dd-MMMM-yyyy';

        //Timepicker functions
        $scope.dates = {
            startDate : moment($scope.currentCampaign.startDate).toDate(),
            endDate : moment($scope.currentCampaign.endDate).toDate(),
            startTime: new Date($scope.currentCampaign.startDate),
            endTime : new Date($scope.currentCampaign.endDate)
        };
        $scope.dates.startTime.setHours(moment($scope.dates.startDate).tz($scope.currentCampaign.timezone).hours());
        $scope.dates.endTime.setHours(moment($scope.dates.endDate).tz($scope.currentCampaign.timezone).hours());

        // campaign type and localized names of types
        $scope.currentCampaignType = {value: unomiCampaignService.getCampaignType($scope.currentCampaign)};
        $scope.$watch("currentCampaignType.value", function (newValue, oldValue) {
            if (angular.isDefined(oldValue) && newValue != oldValue) {
                $scope.localizedCampaignType = unomiCampaignService.getLocalizedCampaignType($scope.currentCampaignType.value);
            }
        });
        $scope.localizedCampaignParam = unomiCampaignService.getLocalizedCampaignParam($scope.currentCampaignType.value);
        $scope.campaignIDTypes = [
            {name: unomiCampaignService.getLocalizedCampaignType('referrer'), value: 'referrer'},
            {name: unomiCampaignService.getLocalizedCampaignType('landing'), value: 'landing'},
            {name: unomiCampaignService.getLocalizedCampaignType('parameter'), value: 'parameter'}
        ];

        // Calendar functions
        $scope.open = function ($event, selector) {
            $event.preventDefault();
            $event.stopPropagation();
            if (selector == 'start')
                $scope.startopened = true;
            if (selector == 'end')
                $scope.endopened = true;
        };

        $scope.openDatePopup = function ($event, selector) {
            $event.preventDefault();
            $event.stopPropagation();
            if (selector == 'start') {
                if (typeof $scope.startDatePicker === 'undefined') {
                    $scope.startDatePicker = {};
                }
                $scope.startDatePicker.opened = true;
            }
            if (selector == 'end') {
                if (typeof $scope.endDatePicker === 'undefined') {
                    $scope.endDatePicker = {};
                }
                $scope.endDatePicker.opened = true;
            }
        };


        $scope.saveCampaign = function () {
            $scope.currentCampaign.metadata.tags = [$scope.currentCampaignType.value];
            $scope.currentCampaign.entryCondition = unomiCampaignService.createCampaignEntryCondition($scope.currentCampaignType);

            $scope.currentCampaign.startDate = moment($scope.dates.startDate).tz($scope.currentCampaign.timezone);
            $scope.currentCampaign.startDate.hours($scope.dates.startTime.getHours());
            $scope.currentCampaign.startDate.minutes($scope.dates.startTime.getMinutes());
            $scope.currentCampaign.startDate.seconds(0);

            $scope.currentCampaign.endDate = moment($scope.dates.endDate).tz($scope.currentCampaign.timezone);
            $scope.currentCampaign.endDate.hours($scope.dates.endTime.getHours());
            $scope.currentCampaign.endDate.minutes($scope.dates.endTime.getMinutes());
            $scope.currentCampaign.endDate.seconds(0);

            if (!$scope.isNew) {
                unomiCampaignService.setCampaign($scope.currentCampaign).then(function () {
                    unomiCampaignService.updatedCampaign = $scope.currentCampaign;
                    $location.path("/campaigndashboard/" + $scope.currentCampaign.metadata.id);
                });
            } else {
                unomiCampaignService.campaignToBeSaved = $scope.currentCampaign;
                $location.path("/campaign/" + $scope.currentCampaign.metadata.id + "/newGoal");
            }
        };

        $scope.getPreviousPage = function () {
            return $scope.isNew ? "#!/campaigns" : ("#!/campaigndashboard/" + $scope.currentCampaign.metadata.id);
        };

        $scope.resetCampaign = function () {
            $route.reload();
        };

        if ($scope.currentCampaign.entryCondition) {
            $scope.currentCampaignType.param = unomiCampaignService.getTypeSpecificCampaignParameter($scope.currentCampaign);

            $scope.hasCampaignStarted = moment().isAfter($scope.currentCampaign.startDate);
            $scope.hasCampaignClosed = moment().isAfter($scope.currentCampaign.endDate);
        }
    }
})();

(function() {
    'use strict';

    angular.module('wemCampaignsApp').controller('CampaignGoalCreateController', CampaignGoalCreateController);

    CampaignGoalCreateController.$inject = [
        '$scope', '$location', '$route', '$timeout', '_', 'i18nService', 'unomiGoalService', 'unomiRulesService',
        'currentCampaign', '$controller', 'unomiCampaignService', 'notificationService', 'unomiQueryService',
        'loadingSpinnerService', 'unomiListService', 'goal', 'modalService'];

    function CampaignGoalCreateController($scope, $location, $route, $timeout, _, i18nService, unomiGoalService, unomiRulesService,
                                          currentCampaign, $controller, unomiCampaignService, notificationService, unomiQueryService,
                                          loadingSpinnerService, unomiListService, goal, modalService) {
        var tags = _.map(ManagersUtils.buildTags(ManagersUtils.campaingTags, i18nService), function (tag, key) {
            return tag;
        });
        $scope.goalTags = angular.copy(tags);

        angular.extend(this, $controller('GoalCreateController', {
            $scope: $scope,
            $location: $location,
            $route: $route,
            $timeout: $timeout,
            i18nService: i18nService,
            _: _,
            unomiGoalService: unomiGoalService,
            unomiQueryService: unomiQueryService,
            notificationService: notificationService,
            unomiListService: unomiListService,
            unomiRulesService: unomiRulesService,
            loadingSpinnerService: loadingSpinnerService,
            goal: goal,
            modalService: modalService
        }));

        $scope.goal.campaignId = currentCampaign.metadata.id;
        // $scope.goal.type = $scope.goalTags[0];

        // execute the save() from the callback to build the goal based on the specific logic
        $scope.saveGoal = function (createForm) {
            if (createForm.$invalid) {
                var parsedErrors = ManagersUtils.parseErrorsInForm(createForm);
                if (parsedErrors && Object.keys(parsedErrors).length > 0) {
                    ManagersUtils.displayErrors(parsedErrors, i18nService, notificationService);
                    return;
                }
            }

            if ($scope.newGoal) {
                $scope.callback.save(function() {
                    loadingSpinnerService.show();
                    $scope.goal.metadata.tags = [$scope.goal.type.id];
                    delete $scope.goal.type;
                    delete $scope.goal.startEvent;
                    var lists = $scope.goal.lists;
                    delete $scope.goal.lists;

                    unomiGoalService.setGoal($scope.goal).then(function () {
                        unomiRulesService.setRule(unomiGoalService.localToServerGoalRule($scope.goal, lists));
                        var newCampaign = unomiCampaignService.campaignToBeSaved;
                        if (newCampaign && newCampaign.metadata.id == $scope.goal.campaignId) {
                            newCampaign.primaryGoal = $scope.goal.metadata.id;
                            unomiCampaignService.setCampaign(newCampaign).then(function () {
                                $timeout(function () {
                                    loadingSpinnerService.hide();
                                    delete unomiCampaignService.campaignToBeSaved;
                                    $location.path("/campaigndashboard/" + $scope.goal.campaignId);
                                }, 1000);
                            });
                        } else {
                            $timeout(function () {
                                loadingSpinnerService.hide();
                                $location.path("/campaigndashboard/" + $scope.goal.campaignId);
                            }, 1000);
                        }
                    });
                });
            } else {
                var saveGoalIfConfirm = function () {
                    $scope.callback.save(function () {
                        loadingSpinnerService.show();
                        $scope.goal.metadata.tags = [$scope.goal.type.id];
                        delete $scope.goal.type;
                        delete $scope.goal.startEvent;
                        delete $scope.goal.lists;

                        unomiGoalService.setGoal($scope.goal).then(function () {
                            $timeout(function () {
                                loadingSpinnerService.hide();
                                $location.path("/campaigndashboard/" + $scope.goal.campaignId + "/goal-report/" + $scope.goal.itemId);
                            }, 1000);
                        });
                    });
                };

                modalService.newAlertModal({
                    title: i18nService.message('serverSettings.manageGoals.title.editConfirm'),
                    bodyMessage: i18nService.message('serverSettings.manageGoals.message.editConfirm')
                }, saveGoalIfConfirm);
            }
        };
    }
})();

(function() {
    'use strict';

    angular.module('wemCampaignsApp').controller('CampaignGoalsListController', CampaignGoalsListController);

    CampaignGoalsListController.$inject = [
        '$scope', '$route', '$location', '$uibModal', 'unomiGoalService', 'unomiQueryService', 'unomiDefinitionService',
        'i18nService', 'unomiCampaignService', 'campaignDetailed', '_', '$controller', 'DTOptionsBuilder',
        'DTColumnBuilder', '$compile', 'modalService', 'dtPagerService'];

    function CampaignGoalsListController($scope, $route, $location, $uibModal, unomiGoalService, unomiQueryService, unomiDefinitionService,
                                         i18nService, unomiCampaignService, campaignDetailed, _, $controller, DTOptionsBuilder,
                                         DTColumnBuilder, $compile, modalService, dtPagerService) {

        angular.extend(this, $controller('GoalsListController', {
            $scope: $scope,
            $route: $route,
            $location: $location,
            $uibModal: $uibModal,
            unomiGoalService: unomiGoalService,
            unomiQueryService: unomiQueryService,
            unomiDefinitionService: unomiDefinitionService,
            i18nService: i18nService,
            currentCampaign: campaignDetailed.campaign,
            _: _
        }));

        // campaign type and localized names of types
        $scope.currentCampaignType = {value: unomiCampaignService.getCampaignType($scope.currentCampaign), param: unomiCampaignService.getTypeSpecificCampaignParameter($scope.currentCampaign)};
        $scope.localizedCampaignType = unomiCampaignService.getLocalizedCampaignType($scope.currentCampaignType.value);
        $scope.localizedCampaignParam = unomiCampaignService.getLocalizedCampaignParam($scope.currentCampaignType.value);

        if (!_.isUndefined(campaignDetailed.campaign)) {
            // timeline data
            var drawCampaignEvents = function () {
                if ($scope.campaignChart) {
                    var eventDates = {};
                    angular.forEach($scope.campaignEvents, function (event) {
                        var eventDateLabel = moment(event.eventDate).format($scope.timelineData.interval.scaleFormat);
                        if (eventDates[eventDateLabel] == undefined) {
                            eventDates[eventDateLabel] = eventDateLabel;
                        }
                    });
                    //now let's paint point with events in red.
                    var ctx = $scope.campaignChart.chart.ctx;
                    ctx.strokeStyle = "#FF0000";

                    if ($scope.campaignChart.datasets) {
                        var min;
                        var max;
                        angular.forEach($scope.campaignChart.datasets, function (dataset) {
                            angular.forEach(dataset.points, function (point) {
                                if (!min || point.y < min) min = point.y;
                                if (!max || point.y > max) max = point.y;
                            });
                        });
                        angular.forEach($scope.campaignChart.datasets[0].points, function (point) {
                            if (eventDates[point.label] != undefined) {
                                ctx.strokeRect(point.x - 10, min - 10, 20, max - min + 20);
                            }
                        });
                    }
                }
            };

            $scope.timelineData.chartOptions = {
                tooltips: {
                    mode: 'label',
                    callbacks: {
                        label: function (tooltipItem, data) {
                            var eventNames = [];
                            angular.forEach($scope.campaignEvents, function (event) {
                                if (tooltipItem.xLabel == (moment(event.eventDate).format($scope.timelineData.interval.scaleFormat))) {
                                    eventNames.push(event.metadata.name);
                                }
                            });
                            var label = tooltipItem.xLabel;
                            if (eventNames.length > 0) {
                                label = "Campaign Events: " + eventNames.join(',');
                            }
                            return label;
                        }
                    }
                },
                animation: {
                    onComplete: function () {
                        $scope.campaignChart = this;
                        drawCampaignEvents();
                    },
                    onProgress: function () {
                        $scope.campaignChart = this;
                        drawCampaignEvents();
                    }
                }
            };
            $scope.timelineData.series = [i18nService.message('serverSettings.manageCampaigns.engaged'), i18nService.message('serverSettings.manageCampaigns.converted')];
            $scope.timelineData.loadData = function (success) {
                var aggregateSessionQuery = {
                    "aggregate": {
                        "type": "date",
                        "parameters": {
                            "interval": this.interval.key,
                            "format": "yyyy-MM-dd"
                        }
                    },
                    "condition": {
                        "type": "booleanCondition",
                        "parameterValues": {
                            "operator": "and",
                            "subConditions": [
                                {
                                    "type": "sessionPropertyCondition",
                                    "parameterValues": {
                                        "propertyName": "scope",
                                        "comparisonOperator": "equals",
                                        "propertyValue": ManagersContext.dmfScope
                                    }
                                }
                            ]
                        }
                    }
                };
                aggregateSessionQuery.condition.parameterValues.subConditions.push(
                    {
                        "type": "sessionPropertyCondition",
                        "parameterValues": {
                            "propertyName": "systemProperties.campaigns." + this.currentCampaign.metadata.id + "Engaged",
                            "comparisonOperator": "between",
                            "propertyValuesDate": [
                                this.currentCampaign.startDate,
                                this.currentCampaign.endDate
                            ]
                        }
                    });
                // get all sessions
                unomiQueryService.query("session", "timeStamp", aggregateSessionQuery).then(function (response) {
                    var aggregateSessionsData = response.data;
                    var datasets = [];
                    datasets[0] = aggregateSessionsData;

                    // get new sessions:
                    aggregateSessionQuery.condition.parameterValues.subConditions.push({
                        "type": "sessionPropertyCondition",
                        "parameterValues": {
                            "propertyName": "systemProperties.goals." + $scope.timelineData.currentCampaign.primaryGoal + "TargetReached",
                            "comparisonOperator": "between",
                            "propertyValuesDate": [
                                $scope.timelineData.currentCampaign.startDate,
                                $scope.timelineData.currentCampaign.endDate
                            ]
                        }
                    });
                    unomiQueryService.query("session", "timeStamp", aggregateSessionQuery).then(function (response) {
                        datasets[1] = response.data;
                        unomiCampaignService.getCampaignEvents($scope.timelineData.currentCampaign.metadata.id, -1, 0, null, {
                            "type": "sessionPropertyCondition",
                            "parameterValues": {
                                "propertyName": "eventDate",
                                "comparisonOperator": "between",
                                "propertyValuesDate": [
                                    $scope.timelineData.currentCampaign.startDate,
                                    $scope.timelineData.currentCampaign.endDate
                                ]
                            }
                        }).then(function (response) {
                            $scope.campaignEvents = response.data.list;
                            success(datasets);
                        });
                    });
                });
            };

            $scope.currentCampaign.KPI = {
                engaged: campaignDetailed.engagedProfiles,
                sessions: campaignDetailed.campaignSessionViews,
                reached: campaignDetailed.campaignSessionSuccess,
                cost_per_visitor: $scope.currentCampaign.cost / campaignDetailed.campaignSessionViews,
                conversion_rate: campaignDetailed.conversionRate * 100,
                conversion_cost: $scope.currentCampaign.cost / campaignDetailed.campaignSessionSuccess,
                page_viewed: 0,
                page_viewed_per_user: 0
            };

            unomiQueryService.nbOfVisits($scope.currentCampaign.metadata.id, $scope.currentCampaign.startDate, $scope.currentCampaign.endDate, function (response) {
                var metricsData = response.data;
                $scope.currentCampaign.KPI.page_viewed = metricsData._sum;
                $scope.currentCampaign.KPI.page_viewed_per_user = metricsData._avg;
            });

            $scope.loading = true;

            $scope.dtOptions = DTOptionsBuilder.newOptions()
                .withOption('processing', true)
                .withOption('serverSide', true)
                .withOption('sDom', 't')
                .withOption('createdRow', createdRow)
                .withOption('order', [[2, 'desc']])
                .withFnServerData(serverData);

            $scope.dtColumns = [
                DTColumnBuilder.newColumn("metadata.name").withTitle(i18nService.message("serverSettings.manageCampaigns.campaignName")),
                DTColumnBuilder.newColumn("metadata.description").withTitle(i18nService.message("serverSettings.manageWem.description")).withOption('defaultContent', ''),
                DTColumnBuilder.newColumn("eventDate").withTitle(i18nService.message("serverSettings.manageCampaigns.eventDate")),
                DTColumnBuilder.newColumn("cost").withTitle(i18nService.message("serverSettings.manageCampaigns.event.cost")),
                DTColumnBuilder.newColumn(null).withTitle(i18nService.message("serverSettings.manageWem.listAction")).notSortable()
                    .renderWith(function (data, type, full, meta) {
                        return "<button type=\"button\" class=\"btn btn-icon command-delete\" ng-click=\"deleteCampaignEvent('" + meta.row + "')\"><span class=\"material-icons\">delete</span></button>";
                    })
            ];

            $scope.deleteCampaignEvent = function (rowIndex) {
                var eventId = $scope.dtInstance.DataTable.row(rowIndex).data().metadata.id;
                var eventName = $scope.dtInstance.DataTable.row(rowIndex).data().metadata.name;
                modalService.newAlertModal({
                    title: i18nService.message("serverSettings.manageWem.delete"),
                    bodyMessage: i18nService.format("serverSettings.manageCampaigns.event.delete.confirm", eventName)
                }, function () {
                    unomiCampaignService.deleteCampaignEvent(eventId).then(function (response) {
                        $scope.campaignEvents = _.filter($scope.campaignEvents, function (item) {
                            return item.metadata.id != eventId;
                        });
                        $scope.dtInstance.DataTable.draw();
                        $scope.campaignChart.draw();
                    });
                });
            };

            $scope.createCampaignEvent = function () {
                var modalInstance = $uibModal.open({
                    templateUrl: ManagersContext.wemAppPath + '/wem-campaigns/campaign-create-event-modal.html',
                    controller: 'CampaignCreateEventModalController',
                    size: 'lg',
                    resolve: {
                        "currentCampaign": function () {
                            return $scope.currentCampaign;
                        }
                    }
                });

                modalInstance.result.then(function (newEvent) {
                    var id = ManagersUtils.generateId();
                    var campaignEventDate = moment(newEvent.eventDate).tz(newEvent.timezone.label);
                    campaignEventDate.hours(newEvent.startTime.getHours());
                    campaignEventDate.minutes(newEvent.startTime.getMinutes());
                    campaignEventDate.seconds(0);
                    var event = {
                        metadata: {
                            id: id,
                            name: newEvent.name,
                            description: newEvent.description,
                            scope: ManagersContext.dmfScope
                        },
                        eventDate: campaignEventDate.toISOString(),
                        cost: newEvent.cost,
                        currency: newEvent.currency.value,
                        campaignId: $scope.currentCampaign.metadata.id,
                        timezone: newEvent.timezone.label
                    };
                    unomiCampaignService.setCampaignEvent(event).then(function () {
                        $scope.campaignEvents.push(event);
                        $scope.dtInstance.DataTable.draw();
                    });
                });
            };

            $scope.displayDate = function (date) {
                return moment(date).tz($scope.currentCampaign.timezone).format('LLLL z');
            };

            $scope.setDtInstance = function (instance) {
                $scope.dtInstance = instance;
            };
        }

        function serverData(sSource, aoData, fnCallback, oSettings) {
            var draw = _.find(aoData, function (x) {
                return x.name == "draw"
            }).value;

            var start = _.find(aoData, function (x) {
                return x.name == "start"
            }).value;

            var length = _.find(aoData, function (x) {
                return x.name == "length"
            }).value;

            var order = _.map(_.find(aoData, function (x) {
                return x.name == "order"
            }).value, function (o) {
                return ($scope.dtColumns[o.column].data ? $scope.dtColumns[o.column].data : $scope.dtColumns[o.column].mData)  + ":" + o.dir;
            }).join(",");

            unomiCampaignService.getCampaignEvents($scope.currentCampaign.metadata.id, length, start, order).then(function (response) {
                var data = response.data;
                var convertedData = [];
                angular.forEach(data.list, function (value, key) {
                    var eventMoment = moment(value.eventDate).tz(value.timezone);
                    var localEventMoment = eventMoment.clone().tz(jstz.determine().name());

                    convertedData.push({
                        "metadata": {
                            name: value.metadata.name,
                            "id": value.metadata.id,
                            "description": value.metadata.description
                        },
                        "eventDate": "<span data-tooltip='" + localEventMoment.format('LLLL z') + "'>" + eventMoment.format('LLLL z') + "&nbsp;(" + localEventMoment.fromNow() + ")" + "</span>",
                        "cost": "<span class='text-success'>(" + value.currency + ")" + value.cost + "</span>"
                    })
                });

                var results = {
                    "sEcho": draw,
                    "iTotalRecords": data.totalSize,
                    "iTotalDisplayRecords": data.totalSize,
                    "aaData": convertedData
                };
                fnCallback(results);
                dtPagerService.initPagerProperties($scope.dtInstance.DataTable, $scope, i18nService);
            },
            function () {
                $scope.searchError = true;
                var results = {
                    "sEcho": draw,
                    "iTotalRecords": 0,
                    "iTotalDisplayRecords": 0,
                    "aaData": []
                };
                fnCallback(results);
            });
        }

        function createdRow(row, data, dataIndex) {
            $compile(angular.element(row).contents())($scope);
        }
    }
})();

(function() {
    'use strict';

    angular.module('wemCampaignsApp').controller('CampaignsListController', CampaignsListController);

    CampaignsListController.$inject = [
            '$scope', 'unomiCampaignService', '$location', 'unomiGoalService', 'unomiRulesService',
            '_', 'DTOptionsBuilder', 'DTColumnBuilder', '$q', '$compile',
            'i18nService', 'modalService', 'dtPagerService'];

    function CampaignsListController($scope, unomiCampaignService, $location, unomiGoalService, unomiRulesService,
                                     _, DTOptionsBuilder, DTColumnBuilder, $q, $compile,
                                     i18nService, modalService, dtPagerService) {
        $scope.loading = true;

        function serverData(sSource, aoData, fnCallback, oSettings) {
            var draw = _.find(aoData, function (x) {
                return x.name == "draw"
            }).value;

            var start = _.find(aoData, function (x) {
                return x.name == "start"
            }).value;

            var length = _.find(aoData, function (x) {
                return x.name == "length"
            }).value;

            var order = _.map(_.find(aoData, function (x) {
                return x.name == "order"
            }).value, function (o) {
                var colName = ($scope.dtColumns[o.column].data ? $scope.dtColumns[o.column].data : $scope.dtColumns[o.column].mData);
                return ManagersUtils.campaignPropertiesForColName[colName] ? (ManagersUtils.campaignPropertiesForColName[colName] + ":" + o.dir) : null;
            }).join(",");

            unomiCampaignService.queryDetails(unomiCampaignService.constructQuery(length, start, order))
                .then(function (response) {
                    var data = response.data;
                    var convertedData = [];
                    angular.forEach(data.list, function (value, key) {
                        var startCampaignMoment = value.campaign.timezone != undefined ? moment(value.campaign.startDate).tz(value.campaign.timezone) : moment(value.campaign.startDate);
                        var endCampaignMoment = value.campaign.timezone != undefined ? moment(value.campaign.endDate).tz(value.campaign.timezone) : moment(value.campaign.endDate);

                        convertedData.push({
                            "id": value.campaign.metadata.id,
                            "name": value.campaign.metadata.name,
                            type: unomiCampaignService.getLocalizedCampaignType(unomiCampaignService.getCampaignType(value.campaign)),
                            "description": value.campaign.metadata.description,
                            "startDate": "<span>" + startCampaignMoment.format('LL') + "</span>",
                            "endDate": "<span>" + endCampaignMoment.format('LL') + "</span>",
                            "conversion": (value.conversionRate * 100).toFixed(2) + "%",
                            "engagedProfiles": value.engagedProfiles,
                            "numberOfGoals": value.numberOfGoals,
                            "primaryGoal" : value.campaign.primaryGoal
                        })
                    });
                    var results = {
                        "sEcho": draw,
                        "iTotalRecords": data.totalSize,
                        "iTotalDisplayRecords": data.totalSize,
                        "aaData": convertedData
                    };
                    fnCallback(results);
                    dtPagerService.initPagerProperties($scope.dtInstance.DataTable, $scope, i18nService);
                    delete $scope.campaignRemoved;
                },
                function () {
                    $scope.searchError = true;
                    var results = {
                        "sEcho": draw,
                        "iTotalRecords": 0,
                        "iTotalDisplayRecords": 0,
                        "aaData": []
                    };
                    fnCallback(results);
                });
        }

        $scope.goalsByTag = {};

        $scope.dtOptions = DTOptionsBuilder.newOptions()
            .withOption('lengthMenu', [ 25, 50, 100 ])
            .withOption('pageLength', 25)
            .withOption('processing', true)
            .withOption('serverSide', true)
            .withOption('sDom', 't')
            .withOption('order', [[3, 'asc']])
            .withOption('createdRow', createdRow)
            .withFnServerData(serverData);

        $scope.dtColumns = [
            {
                "data": 'name',
                "title": i18nService.message("serverSettings.manageCampaigns.campaignName"),
                "width": "10%"
            },
            {
                data: 'type',
                title: i18nService.message("serverSettings.manageCampaigns.type.short"),
                width: '10%'
            },
            {
                "data": 'description',
                "title": i18nService.message("serverSettings.manageWem.description"),
                "width": "10%"
            },
            {
                "data": "startDate",
                "title": i18nService.message("serverSettings.manageCampaigns.startDate"),
                "width": "10%"
            },
            {
                "data": "endDate",
                "title": i18nService.message("serverSettings.manageCampaigns.endDate"),
                "width": "10%"
            },
            DTColumnBuilder.newColumn("engagedProfiles").withTitle(i18nService.message("serverSettings.manageCampaigns.engaged")).notSortable()
                .withOption("width", "5%"),
            DTColumnBuilder.newColumn("conversion").withTitle(i18nService.message("serverSettings.manageCampaigns.conversion.rate")).notSortable()
                .withOption("width", "5%"),
            DTColumnBuilder.newColumn("numberOfGoals").withTitle(i18nService.message("serverSettings.manageCampaigns.goals")).notSortable()
                .withOption("width", "5%"),
            DTColumnBuilder.newColumn(null).withTitle(i18nService.message("serverSettings.manageWem.listAction")).notSortable()
                .renderWith(actionsHtml).withOption("width", "180px").withOption("contentPadding", "0")
        ];

        function createdRow(row, data, dataIndex) {
            console.log("Row is created: " + row);
            // Recompiling so we can bind Angular directive to the DT
            $compile(angular.element(row).contents())($scope);
        }

        function rowCallback(row, aData, iDisplayIndex, iDisplayIndexFull) {
            // Unbind first in order to avoid any duplicate handler (see https://github.com/l-lin/angular-datatables/issues/87)
            $('td:not(:last-child)', row).unbind('click');
            $('td:not(:last-child)', row).bind('click', function () {
                $scope.$apply(function () {
                    $location.path('/campaigndashboard/' + aData.metadata.id);
                });
            });
            return row;
        }

        function actionsHtml(data, type, full, meta) {
            return "<button title=\"" + i18nService.message("serverSettings.manageGoals.campaignDashboard") + "\" type=\"button\" class=\"btn btn-icon command-dashboard\" ng-click=\"goToDashboard('" + data.id + "')\"><i class=\"material-icons\">multiline_chart</i></button> " +
                "<button title=\"" + i18nService.message("serverSettings.manageCampaigns.manageEngagedProfiles") + "\" type=\"button\" class=\"btn btn-icon command-profiles\" ng-click=\"goToEngagedProfiles('" + data.id + "')\" ><i class=\"material-icons\">people</i></button>" +
                "<button title=\"" + i18nService.message("serverSettings.manageCampaigns.manageConvertedProfiles") + "\" type=\"button\" class=\"btn btn-icon command-profiles\" ng-click=\"goToConvertedProfiles('" + data.id + "', '" + data.primaryGoal + "')\" ><i class=\"material-icons\">person</i></button>" +
                "<button title=\"" + i18nService.message("serverSettings.manageWem.delete") + "\" type=\"button\" class=\"btn btn-icon command-delete\" ng-click=\"deleteCampaign('" + meta.row + "')\"><i class=\"material-icons\">delete</i></button>";
        }

        $scope.goToDashboard = function (id) {
            $location.path("/campaigndashboard/" + id);
        };

        $scope.goToEngagedProfiles = function (id) {
            $location.path("/campaign/" + id + "/profiles");
        };

        $scope.goToConvertedProfiles = function (campaignId, goalId) {
            $location.path("/campaign/" + campaignId + "/converted/" + goalId);
        };

        $scope.goalsByTag = ManagersUtils.buildTags(ManagersUtils.campaingTags, i18nService);

        $scope.deleteCampaign = function (rowIndex) {
            var id = $scope.dtInstance.DataTable.row(rowIndex).data().id;
            var name = $scope.dtInstance.DataTable.row(rowIndex).data().name;
            modalService.newAlertModal({
                title: i18nService.message("serverSettings.manageWem.delete"),
                bodyMessage: i18nService.format("serverSettings.manageCampaigns.delete.confirm", name)
            }, function () {
                unomiGoalService.getAllForCampaign(id).then(function (response) {
                    var goalsMetadata = response.data;
                    unomiCampaignService.deleteCampaign(id).then(function () {
                        if(goalsMetadata && goalsMetadata.length) {
                            var promises = [];
                            _.forEach(goalsMetadata, function (goal) {
                                promises.push(unomiRulesService.deleteRule(unomiGoalService.getAddToListRulePrefix() + goal.id));
                            });
                            $q.all(promises).then(function (response) {
                                console.log("Add to list rules deleted successfully");
                            });
                        }
                    });
                    // reload the table
                    $scope.dtInstance.DataTable.draw();
                });
            });
        };

        $scope.setDtInstance = function (instance) {
            $scope.dtInstance = instance;
        };
    }
})();
