(function() {
    'use strict';

    angular.module('wemApp.components').directive('wemHtmlTagPicker', wemHtmlTagPicker);

    function wemHtmlTagPicker() {
        return {
            restrict: "E",
            scope: {
                selectedTagId: '=ngModel',
                origin: '@',
                tag: '@',
                attrs: '@',
                displayAttr: '@',
                disabled: '@',
                label: '@',
                name: '@',
                required: '='
            },
            templateUrl: ManagersContext.wemAppPath + "/components/pickers/wem-html-tag-picker.directive.html",
            controller: WemHtmlTagPickerController,
            link: linkFunc
        };

        function linkFunc(scope, element, attributes) {
            var tag = attributes.tag ? attributes.tag : "form";
            var attrs = attributes.attrs ? attributes.attrs.split('|') : ["name", "id"];
            var displayAttr = attributes.displayAttr;

            scope.toBoolean = function (value) {
                if (typeof value === 'function') {
                    value = true;
                } else if (value && value.length !== 0) {
                    var v = angular.lowercase("" + value);
                    value = !(v == 'f' || v == '0' || v == 'false' || v == 'no' || v == 'n' || v == '[]');
                } else {
                    value = false;
                }
                return value;
            };

            var displayIframe = function (src) {
                var $iframe = $("<iframe></iframe>");
                $iframe.css("display", "none");
                $iframe.on("load", function () {
                    var tags = [];
                    $iframe.contents().find(tag).each(function () {
                        var $element = $(this);
                        for (var i = 0; i < attrs.length; i++) {
                            var attr = attrs[i];
                            if ($element.is("[" + attr + "]")) {
                                var id = $element.attr(attr);
                                tags.push({
                                    "id": id,
                                    "display": (displayAttr && $element.is("[" + displayAttr + "]")) ? $element.attr(displayAttr) : id
                                });
                                break;
                            }
                        }
                    });
                    scope.$apply(function () {
                        scope.tags = tags;
                        scope.loaded = true;
                        scope.loading = false;
                    });
                });
                $iframe.attr("src", src);
                element.append($iframe);
            };

            attributes.$observe('origin', function (value) {
                if (value) {
                    scope.loaded = false;
                    scope.loading = true;
                    element.find("iframe").remove();
                    displayIframe(ManagersContext.baseLive + value + ".html?skipWem=true");
                }
            });
        }
    }

    WemHtmlTagPickerController.$inject = ['$scope'];

    function WemHtmlTagPickerController($scope) {
        $scope.tags = [];
        $scope.loaded = false;
        $scope.loading = false;
    }
})();