(function() {
    'use strict';

    angular.module('wemApp.components').directive('wemSiteLanguagePicker', wemSiteLanguagePicker);

    function wemSiteLanguagePicker() {
        return {
            restrict: "E",
            scope: {
                selectedLanguage: '=ngModel'
            },
            templateUrl: ManagersContext.wemAppPath + (wemAppIsNewUI ? "/components/pickers/wem-site-language-picker.directive.html" : "/components/pickers/wem-site-language-picker.directive.legacy.html"),
            controller: WemSiteLanguagePickerController
        };
    }

    WemSiteLanguagePickerController.$inject = ['$scope', 'i18nService'];

    function WemSiteLanguagePickerController($scope, i18nService) {
        $scope.root = {};
        $scope.loaded = false;

        $.ajax({
            type: "GET",
            dataType: "json",
            url: ManagersContext.baseLive + ManagersContext.currentSitePath + ".languages.json"
        }).done(function (data) {
            $scope.$apply(function () {
                if (data && data.length > 0) {
                    data.push({
                        value: i18nService.message('serverSettings.languagePicker.anyLanguages')
                    });
                    $scope.siteLanguages = data;
                    $scope.loaded = true;
                }
            });
        });

    }
})();