(function() {
    'use strict';

    angular.module('wemApp.components').directive('wemLoadingSpinner', wemLoadingSpinner);

    function wemLoadingSpinner() {
        return {
            restrict: 'E',
            scope: {
                show: '@'
            },
            templateUrl: ManagersContext.wemAppPath + '/components/wem-loading-spinner.directive.html',
            controller: WemLoadingSpinnerController,
            controllerAs: 'loadingSpinnerCtrl',
            bindToController: true
        };
    }

    WemLoadingSpinnerController.$inject = ['loadingSpinnerService'];

    function WemLoadingSpinnerController(loadingSpinnerService) {
        var vm = this;

        loadingSpinnerService.register({
            'show': function() {
                vm.show = true;
            },
            'hide': function() {
                vm.show = false;
            }
        });
    }
})();