(function() {
    'use strict';

    angular.module('wemApp.services').service('validationUtilsService', validationUtilsService);

    validationUtilsService.$inject = ['loadingSpinnerService'];

    function validationUtilsService(loadingSpinnerService) {
        return {
            getFormInPage: getFormInPage
        };

        function getFormInPage($scope, formId, path, callback) {
            var id = "formFrame" + Math.random().toString(16).substring(2);
            var tries = 5;
            console.log("creating frame " + id);
            var $iframe = $("<iframe id='" + id + "'></iframe>");
            $iframe.css("display", "none");
            $("body").append($iframe);
            loadingSpinnerService.show();
            $iframe.ready(function () {
                console.log("iframe " + id + " loaded");
                var _timeOut = function () {
                    $scope.$apply(function () {
                        var _form = $iframe.contents().find("form[name='" + formId + "']");
                        if (!_form || _form.length == 0) {
                            _form = $iframe.contents().find("#" + formId);
                        }
                        if ((_form && _form.length > 0 && _form.find(":input").length > 0) || tries == 0) {
                            console.log("found form : " + _form.length);
                            $("#" + id).remove();
                            loadingSpinnerService.hide();
                            return callback(_form);
                        } else {
                            tries--;
                            console.log("not found, retrying : " + tries);
                            window.setTimeout(_timeOut, 1000);
                        }
                    });
                };
                window.setTimeout(_timeOut, 1000);
            });
            $iframe.attr("src", ManagersContext.baseLive + path + ".html?skipWem=true");
        }
    }
})();