(function() {
    'use strict';

    angular.module('wemFormMappingApp').config(wemFormMappingAppConfig);

    wemFormMappingAppConfig.$inject = ['$routeProvider'];

    function wemFormMappingAppConfig($routeProvider) {
        $routeProvider
            .when('/list', {
                templateUrl: ManagersContext.wemAppPath + '/wem-form-mapping/list-form-mapping.html',
                controller: 'ListFormMappingController'
            })
            .when('/add', {
                templateUrl: ManagersContext.wemAppPath + '/wem-form-mapping/edit-form-mapping.html',
                controller: 'EditFormMappingController',
                resolve: {
                    formMapping: function() {
                        return {
                            id: 'form-mapping_' + ManagersUtils.generateId(),
                            scope: ManagersContext.dmfScope,
                            additionalPaths: []
                        };
                    },
                    isNew: function() {
                        return true;
                    }
                }
            })
            .when('/edit/:formMappingId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-form-mapping/edit-form-mapping.html',
                controller: 'EditFormMappingController',
                resolve: {
                    formMapping: function( $q, $route, formMappingService) {
                        var formMapping = $q.defer();
                        formMappingService.get($route.current.params.formMappingId).then(
                            function (response) {
                                formMapping.resolve(formMappingService.serverToLocalFormMapping(response.data));
                            }
                        );
                        return formMapping.promise;
                    },
                    isNew: function() {
                        return false;
                    }
                }
            })
            .otherwise( {
                redirectTo: '/list'
            });
    }
})();
