(function() {
    'use strict';

    angular.module('wemGoalsApp').controller('GoalFormGoalController', GoalFormGoalController);

    GoalFormGoalController.$inject = ['$scope', 'validationUtilsService', 'modalService', 'i18nService'];

    function GoalFormGoalController($scope, validationUtilsService, modalService, i18nService) {
        $scope._goal = {};
        $scope.goal = $scope.$parent.goal;
        var subConditions = ManagersUtils.getProperty($scope.goal, "targetEvent.parameterValues.subConditions");
        if (subConditions) {
            for (var i = 0; i < subConditions.length; i++) {
                var subCondition = subConditions[i];
                if (subCondition.type == "formEventCondition") {
                    $scope._goal.targetForm = ManagersUtils.getProperty(subCondition, "parameterValues.formId");
                }
                if (subCondition.type == "sourceEventPropertyCondition") {
                    $scope._goal.startPath = ManagersUtils.getProperty(subCondition, "parameterValues.path");
                }
            }
        }

        var doSave = function(callback) {
            // construct page visit event:
            $scope.goal.metadata.enabled = true;
            $scope.goal.startEvent = {
                "parameterValues": {
                    "pagePath": $scope._goal.startPath
                },
                "type": "pageViewEventCondition"
            };
            $scope.goal.targetEvent = {
                "type": "booleanCondition",
                "parameterValues": {
                    "operator": "and",
                    "subConditions": [
                        {
                            "parameterValues": {
                                "formId": $scope._goal.targetForm
                            },
                            "type": "formEventCondition"
                        },
                        {
                            "parameterValues": {
                                "path": $scope._goal.startPath
                            },
                            "type": "sourceEventPropertyCondition"
                        }
                    ]
                }
            };

            if(callback) {
                callback();
            }
        };

        if ($scope.callback) {
            $scope.callback.validate = function (callback) {
                if (callback) {
                    callback();
                }
            };

            $scope.callback.save = function (callback) {
                doSave(callback);
            }
        }
    }
})();
