(function() {
    'use strict';

    angular.module('wemGoalsApp').controller('GoalFunnelGoalController', GoalFunnelGoalController);

    GoalFunnelGoalController.$inject = ['$scope'];

    function GoalFunnelGoalController($scope) {
        $scope._goal = {};
        $scope.goal = $scope.$parent.goal;
        $scope._goal.targetPath = ManagersUtils.getProperty($scope.goal, "targetEvent.parameterValues.pagePath");
        $scope._goal.startPath = ManagersUtils.getProperty($scope.goal, "startEvent.parameterValues.pagePath");

        var doSave = function (callback) {
            // construct funnel events:
            $scope.goal.metadata.enabled = true;
            $scope.goal.targetEvent = {
                "parameterValues": {
                    "pagePath": $scope._goal.targetPath
                },
                "type": "pageViewEventCondition"
            };
            $scope.goal.startEvent = angular.copy($scope.goal.targetEvent);
            $scope.goal.startEvent.parameterValues.pagePath = $scope._goal.startPath;

            if(callback) {
                callback();
            }
        };

        if ($scope.callback) {
            $scope.callback.validate = function (callback) {
                if (callback) {
                    callback();
                }
            };

            $scope.callback.save = function (callback) {
                doSave(callback);
            }
        }
    }
})();
