(function() {
    'use strict';

    angular.module('wemGoalsApp').controller('GoalVideoGoalController', GoalVideoGoalController);

    GoalVideoGoalController.$inject = ['$scope'];

    function GoalVideoGoalController($scope) {
        $scope._goal = {};
        $scope.goal = $scope.$parent.goal;
        $scope._goal.startPath = ManagersUtils.getProperty($scope.goal, "startEvent.parameterValues.pagePath");
        var subConditions = ManagersUtils.getProperty($scope.goal, "targetEvent.parameterValues.subConditions");
        if (subConditions) {
            for (var i = 0; i < subConditions.length; i++) {
                var subCondition = subConditions[i];
                if (subCondition.type == "videoViewEventCondition") {
                    $scope._goal.targetVideo = ManagersUtils.getProperty(subCondition, "parameterValues.videoId");
                }
            }
        }

        var doSave = function (callback) {
            // construct page visit event:
            $scope.goal.metadata.enabled = true;
            $scope.goal.startEvent = {
                "parameterValues": {
                    "pagePath": $scope._goal.startPath
                },
                "type": "pageViewEventCondition"
            };
            $scope.goal.targetEvent = {
                "type": "booleanCondition",
                "parameterValues": {
                    "operator": "and",
                    "subConditions": [
                        {
                            "parameterValues": {
                                "videoId": $scope._goal.targetVideo
                            },
                            "type": "videoViewEventCondition"
                        },
                        {
                            "parameterValues": {
                                "path": $scope._goal.startPath
                            },
                            "type": "sourceEventPropertyCondition"
                        }
                    ]
                }
            };

            if(callback) {
                callback();
            }
        };

        if ($scope.callback) {
            $scope.callback.validate = function (callback) {
                if (callback) {
                    callback();
                }
            };

            $scope.callback.save = function (callback) {
                doSave(callback);
            }
        }
    }
})();
