(function() {
    'use strict';

    angular.module('wemGoalsApp').run(wemGoalsAppRun);

    wemGoalsAppRun.$inject = ['$rootScope', '$location', 'jcrService', 'modalService', 'i18nService'];

    function wemGoalsAppRun($rootScope, $location, jcrService, modalService, i18nService) {
        $rootScope.getCurrentModuleResource = function (resourcePath) {
            return ManagersUtils.getCurrentModuleResource(resourcePath);
        };

        $rootScope.getGoalViewTemplate = function (goal) {
            if (goal && goal.metadata && goal.metadata.tags && goal.metadata.tags.length > 0) {
                return ManagersContext.wemAppPath + "/wem-goals/goal-" + goal.metadata.tags[0] + "-view.html";
            }
        };

        $rootScope.getGoalLinksView = function () {
            return ManagersContext.wemAppPath + "/wem-goals/goal-widget-links.directive.html";
        };

        var history = [];

        $rootScope.$on('$routeChangeSuccess', function () {
            history.push($location.$$path);
        });

        $rootScope.back = function () {
            var prevUrl = history.length > 1 ? history.splice(-2)[0] : "/";
            $location.path(prevUrl);
        };
    }
})();
