(function() {
    'use strict';

    angular.module('wemImportConfigsApp').config(wemImportConfigsAppConfig);

    wemImportConfigsAppConfig.$inject = ['$routeProvider'];

    function wemImportConfigsAppConfig($routeProvider) {
        $routeProvider
            .when('/import-configs', {
                templateUrl: ManagersContext.wemAppPath + '/wem-import-configs/import-configs-list.html',
                controller: 'ImportConfigsListController',
                controllerAs: 'importConfigListCtrl'
            })
            .when('/import-configs/:configId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-import-configs/import-config-edit.html',
                controller: 'ImportConfigsEditController',
                controllerAs: 'importConfigsEditCtrl',
                resolve: {
                    // resolve profile here to avoid async issue using deferred API
                    "currentImportConfig": function ($q, $route, unomiImportConfigService) {
                        if($route.current.params.configId == 'new') {
                            return {};
                        }
                        var currentImportConfig = $q.defer();
                        unomiImportConfigService.getImportConfig($route.current.params.configId).then(function (response) {
                            currentImportConfig.resolve(response.data);
                        });
                        return currentImportConfig.promise;
                    }
                }
            })
            .otherwise({
                redirectTo: angular.isDefined(ManagersContext.wemDefaultRoute) ? ('/' + ManagersContext.wemDefaultRoute) : '/import-configs'
            });
    }
})();