(function() {
    'use strict';

    angular.module('wemInternalSearchesApp').controller('InternalSearchDetailsController', InternalSearchDetailsController);

    InternalSearchDetailsController.$inject = ['$scope', 'internalSearchService', 'i18nService', 'notificationService'];

    function InternalSearchDetailsController($scope, internalSearchService, i18nService, notificationService) {
        $scope.$on("$routeChangeError", function (evt, current, previous, rejection) {
            if (rejection == "profile_not_found") {
                notificationService.errorToast(i18nService.message("route.reject.profile_not_found"))
            }
        });

        $scope.searchDetail = internalSearchService.getSearchDetails();

        $scope.getTabTitle = function (key) {
            return i18nService.message(key);
        };
    }
})();