(function() {
    'use strict';

    angular.module('wemInternalSearchesApp').config(wemInternalSearchesAppConfig);

    wemInternalSearchesAppConfig.$inject = ['$routeProvider'];

    function wemInternalSearchesAppConfig($routeProvider) {
        $routeProvider
            .when('/searches', {
                templateUrl: ManagersContext.wemAppPath + '/wem-internal-searches/internal-searches-list.html',
                controller: 'InternalSearchesListController'
            })
            .when('/search/:searchId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-internal-searches/internal-search-details.html',
                controller: 'InternalSearchDetailsController'
            })
            .when('/search/:searchId/profile/:profileId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/manage-profile.html',
                controller: 'ManageProfileController',
                resolve: {
                    // resolve profile here to avoid async issue using deferred API
                    "profile": function ($q, $route, unomiProfileService) {
                        var profile = $q.defer();
                        unomiProfileService.getProfile($route.current.params.profileId).then(function (response) {
                            var profileData = response.data;
                            if(profileData) {
                                profile.resolve(profileData);
                            } else {
                                profile.reject("profile_not_found")
                            }

                        });
                        return profile.promise;
                    }
                }
            })
            .when('/search/:searchId/profile/:profileId/:sessionId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/profile-session.html',
                controller: 'ProfileSessionController'
            })
            .otherwise({
                redirectTo: '/searches'
            });
    }
})();
