(function() {
    'use strict';
    angular.module('wemProfilesApp').controller('AddScoreModifiersModalController', AddScoreModifiersModalController);

    AddScoreModifiersModalController.$inject = ['$scope', '$uibModalInstance', 'unomiProfileService', 'scorings', 'selectedProfile', 'profileType'];

    function AddScoreModifiersModalController($scope, $uibModalInstance, unomiProfileService, scorings, selectedProfile, profileType) {
        $scope.scorings = scorings;
        $scope.selectedProfile = selectedProfile;
        $scope.profileType = profileType;
        if (!$scope.selectedProfile.systemProperties.scoreModifiers) {
            $scope.selectedProfile.systemProperties.scoreModifiers = {};
        }

        $scope.save = function () {
            var target = $scope.profileType=="profile"?"profiles":"personas";
            _.each($scope.selectedProfile.systemProperties.scoreModifiers, function (value, key) {
                if (!value) {
                    delete $scope.selectedProfile.systemProperties.scoreModifiers[key];
                }
            });

            unomiProfileService.saveProfile($scope.selectedProfile, target).then(function (response) {
                $uibModalInstance.close($scope.selectedProfile);
            });
        };

        $scope.cancel = function () {
            $uibModalInstance.dismiss('cancel');
        };
    }
})();