(function() {
    'use strict';

    angular.module('wemProfilesApp').controller('AddToListsModalController', AddToListsModalController);

    AddToListsModalController.$inject = ['$scope', '$uibModalInstance', 'unomiProfileService', 'lists', 'selectedProfile', 'profileType'];

    function AddToListsModalController($scope, $uibModalInstance, unomiProfileService, lists, selectedProfile, profileType) {
        $scope.lists = lists;
        $scope.selectedProfile = selectedProfile;
        $scope.profileType = profileType;

        if (!$scope.selectedProfile.systemProperties.lists) {
            $scope.selectedProfile.systemProperties.lists = [];
        }

        $scope.save = function () {
            var target = $scope.profileType=="profile"?"profiles":"personas";
            unomiProfileService.saveProfile($scope.selectedProfile, target).then(function (response) {
                $uibModalInstance.close($scope.selectedProfile);
            });
        };

        $scope.cancel = function () {
            $uibModalInstance.dismiss('cancel');
        };
    }
})();