(function() {
    'use strict';

    angular.module('wemProfilesApp').controller('AddToSegmentsModalController', AddToSegmentsModalController);

    AddToSegmentsModalController.$inject = ['$scope', '$uibModalInstance', 'unomiProfileService', 'segments', 'selectedProfile', 'profileType'];

    function AddToSegmentsModalController($scope, $uibModalInstance, unomiProfileService, segments, selectedProfile, profileType) {
        $scope.segments = segments;
        $scope.selectedProfile = selectedProfile;
        $scope.profileType = profileType;

        if (!$scope.selectedProfile.segments) {
            $scope.selectedProfile.segments = [];
        }

        $scope.save = function () {
            var target = $scope.profileType=="profile"?"profiles":"personas";
            unomiProfileService.saveProfile($scope.selectedProfile, target).then(function (response) {
                $uibModalInstance.close($scope.selectedProfile);
            });
        };

        $scope.cancel = function () {
            $uibModalInstance.dismiss('cancel');
        };
    }
})();