(function() {
    'use strict';

    angular.module('wemProfilesApp').run(wemProfilesAppRun);

    wemProfilesAppRun.$inject = ['$rootScope', 'i18nService', '$route'];

    function wemProfilesAppRun($rootScope, i18nService, $route) {
        $rootScope.getCurrentModuleResource = function (resourcePath) {
            return ManagersUtils.getCurrentModuleResource(resourcePath);
        };

        $rootScope.getI18n = function (key) {
            return i18nService.message(key);
        };

        $rootScope.reload = function () {
            $route.reload();
        };
        $rootScope.selectedColumns = {};
        $rootScope.selectedColumns.visitors = ['lastVisit'];
        $rootScope.selectedColumns.contacts = ['email', 'phoneNumber', 'twitterId'];
        $rootScope.selectedColumns.leads = ['firstName', 'lastName', 'leadAssignedTo'];
        $rootScope.selectedColumns.personas = ['firstName', 'lastName', 'description'];
        $rootScope.selectedColumns.defaultValues = ['email', 'lastVisit'];

        if (typeof(Storage) !== "undefined") {
            if (localStorage.selectedColumns) {
                $rootScope.selectedColumns = JSON.parse(localStorage.selectedColumns);
            }
        }
    }
})();