(function() {
    'use strict';
    angular.module('wemProfilesApp').controller('SearchProfilesModalController', SearchProfilesModalController);

    SearchProfilesModalController.$inject = ['$scope', '$uibModalInstance', 'unomiProfileService', 'i18nService', 'notificationService'];

    function SearchProfilesModalController($scope, $uibModalInstance, unomiProfileService, i18nService, notificationService) {
        console.log(unomiProfileService.getSelectedTab());
        $scope.searchCondition = angular.copy(unomiProfileService.getSelectedTab().searchCondition);
        $scope.conditionTypes = unomiProfileService.getSelectedTab().conditionTypes;
        $scope.eventConditionTypes = unomiProfileService.getSelectedTab().eventConditionTypes;

        $scope.searchProfiles = function () {
            if ($scope.searchProfilesForm.$invalid) {
                $scope.searchProfilesForm.showErrors = true;

                var parsedErrors = ManagersUtils.parseErrorsInForm($scope.searchProfilesForm);
                if (parsedErrors && Object.keys(parsedErrors).length > 0) {
                    ManagersUtils.displayErrors(parsedErrors, i18nService, notificationService);
                    return;
                }
            }

            unomiProfileService.setSelectedTabSearchConditionType($scope.searchCondition.type);
            unomiProfileService.setSelectedTabSearchConditionParameterValues($scope.searchCondition.parameterValues);
            $uibModalInstance.close();
        };

        $scope.hasError = function (propertyName) {
            return ManagersUtils.hasErrors($scope.searchProfilesForm, $scope.searchProfilesForm, propertyName);
        };

        $scope.cancel = function () {
            $uibModalInstance.dismiss();
        };
    }
})();