(function() {
    'use strict';

    angular.module('wemRulesApp').config(wemRulesAppConfig);

    wemRulesAppConfig.$inject = ['$routeProvider'];

    function wemRulesAppConfig($routeProvider) {
        $routeProvider
            .when('/rules', {
                templateUrl: ManagersContext.wemAppPath + '/wem-rules/rules-list.html',
                controller: 'RulesListController',
                controllerAs: 'rulesListCtrl'

            })
            .when('/rule/advanced/:ruleId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-rules/rule-advanced-edit.html',
                controller: 'RuleAdvancedEditController',
                controllerAs : 'ruleAdvancedEditCtrl'
            })
            .when('/rule/simple/:ruleId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-rules/rule-simple-edit.html',
                controller: 'RuleSimpleEditController',
                controllerAs: 'ruleSimpleEditCtrl'
            })
            .otherwise({
                redirectTo: '/rules'
            });
    }

})();
