(function() {
    'use strict';

    angular.module('wemRulesApp').service('rulesService', rulesService);

    rulesService.$inject = ['unomiRulesService', '$q'];

    function rulesService(unomiRulesService, $q) {
        return {
            createSimpleRule : createSimpleRule,
            createAdvancedRule : createAdvancedRule,
            loadOrCreateRule: loadOrCreateRule
        };

        function createSimpleRule() {
            var newRuleId = ManagersUtils.generateId();
            return {
                metadata: {
                    id: newRuleId,
                    scope: ManagersContext.dmfScope,
                    tags: ['simpleRule'],
                    enabled: true
                },
                condition: {
                    "parameterValues": {
                        "subConditions": [],
                        "operator": "and"
                    },
                    "type": "booleanCondition"
                },
                "actions": []
            };
        }

        function createAdvancedRule() {
            var newRuleId = ManagersUtils.generateId();
            return {
                metadata: {
                    id: newRuleId,
                    scope: ManagersContext.dmfScope,
                    enabled: true
                },
                condition: {
                    "parameterValues": {
                        "subConditions": [],
                        "operator": "and"
                    },
                    "type": "booleanCondition"
                },
                "actions": []
            };
        }

        function loadOrCreateRule(ruleId) {
            var rule = $q.defer();
            if (ruleId == "newSimpleRule") {
                rule.resolve(createSimpleRule())
            } else if (ruleId == "newAdvancedRule") {
                rule.resolve(createAdvancedRule())
            } else {
                unomiRulesService.getRule(ruleId).then(function (response) {
                    rule.resolve(response.data);
                });
            }
            return rule.promise;
        }

    }


})();