<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="wem" uri="http://www.jahia.org/tags/wem" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="variantNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<jsp:include page="../../commons/adminBaseImports.ui-bootstrap.jsp"/>

<template:addResources type="css" resources="marketing-factory/legacy/perso-opti-customEditEngine.css"/>

<template:addResources type="javascript"
                       resources="
                       marketing-factory/vendor/jquery-ui-1.12.1.min.js,
                       marketing-factory/vendor/sortable.js,
                       marketing-factory/builds/wemManagePersonalizationConditionsApp.js"/>

<c:choose>
    <c:when test="${wem:isAvailable(renderContext.site.siteKey)}">
        <c:set var="variants" value="${jcr:getChildrenOfType(currentNode, 'wemnt:pageVariant')}" />

        <script type="text/javascript">
            var currentDMFPageNodeUUID = "${currentNode.identifier}";
            var urlBase = '${url.base}';

            var persoType = 'page';
            var variants = {};
            variants["${currentNode.identifier}"] = {
                "id": "${currentNode.identifier}",
                "name": "${functions:escapeJavaScript(currentNode.displayableName)}",
                "systemName": "${functions:escapeJavaScript(currentNode.unescapedName)}",
                "position": "${functions:default(currentNode.properties['wem:position'].long, 0)}",
                "jsonFilter": ${functions:default(currentNode.properties['wem:jsonFilter'].string, 'null')},
                "tab": "${functions:default(currentNode.properties['wem:tab'].string, '')}",
                "parent" : true
            };
            <c:forEach items="${variants}" var="variantNode" varStatus="loop">
            variants["${variantNode.identifier}"] = {
                "id": "${variantNode.identifier}",
                "name": "${functions:escapeJavaScript(variantNode.displayableName)}",
                "systemName": "${functions:escapeJavaScript(variantNode.unescapedName)}",
                "position": "${functions:default(variantNode.properties['wem:position'].long, (loop.index + 1))}",
                "jsonFilter": ${functions:default(variantNode.properties['wem:jsonFilter'].string, 'null')},
                "tab": "${functions:default(variantNode.properties['wem:tab'].string, '')}"
            };
            </c:forEach>

            // NECESSARY TO FIX IE ISSUE RELATED TO IFRAME AND FOCUS ON INPUTS, QAMF-223, QAMF-453
            $(document).ready(function(){
                $("#ieFixInputs").focus().hide();
            })
        </script>

        <input id="ieFixInputs" type="text">
        <div ng-app="wemManagePersonalizationConditionsApp">
            <div ng-controller="ManagePersonalizationConditionsController" class="opttstpage">

                <div class="group variants-table">
                    <div class="selectModCont">
                        <label message-key="label.engineTab.dmfconditions.selectedVariant" class="fixLabelPos"></label>
                    </div>
                    <div ui-sortable="sortableOptions" ng-model="toBeSaveVariants" class="sortableListContainer">
                        <ul ng-repeat="variant in toBeSaveVariants | orderBy:'position'" class="list" ng-class="{'active':variant.id === toBeSaveVariant.id}">
                            <li class="item dragHandleContainer">
                                <i class="material-icons dragndrop">drag_handle</i>
                            </li>
                            <li class="item radioBtn">
                                <div ng-click="selectVariant(variant)"><i class="material-icons check">{{(variant.id === toBeSaveVariant.id) ? 'radio_button_checked' : 'radio_button_unchecked'}}</i></div>
                            </li>
                            <li class="item itemLarge">
                                {{trimVariantName(variant.name) + ' (' + variant.systemName + ')'}}
                            </li>
                        </ul>
                    </div>
                </div>
                <hr class="selectVariantSep" ng-show="toBeSaveVariant"/>
                <form name="personalizedPage" novalidate="" ng-show="toBeSaveVariant" class="botnFormPositionFix">
                    <div class="group condBuilderMarginFix">
                        <div class="selectModCont">
                            <label message-key="label.engineTab.dmfconditions.conditions" class="fixLabelPos"></label>
                            <div class="btn-group tabsperscontsel" role="group">
                                <ul class="list checkboxList">
                                    <li ng-repeat="tab in tabs" ng-click="selectTab(tab)" class="item radioBtn">
                                        <i class="material-icons check" ng-class="{'active':((tab === toBeSaveVariant.tab) && toBeSaveVariant.init) || (tab === 'no-condition' && !toBeSaveVariant.init)}">{{(((tab === toBeSaveVariant.tab) && toBeSaveVariant.init) || (tab === 'no-condition' && !toBeSaveVariant.init)) ? 'radio_button_checked' : 'radio_button_unchecked'}}</i>
                                        <div class="selectRadioLabel"><span message-key="label.engineTab.dmfconditions.type.{{tab}}"/></div>
                                    </li>
                                </ul>
                            </div>
                        </div>
                    </div>

                    <div class="row" ng-if="toBeSaveVariant.init">
                        <div class="groupaltforcond">
                            <a href="" class="btn btn-primary" aria-expanded="false" ng-click="toBeSaveVariant.init = false">
                                <i class="material-icons">remove_circle_outline</i>
                                <span message-key="label.engineTab.dmfconditions.remove"></span>
                            </a>

                            <fieldset>
                                <input type="hidden" name="condition" ng-model="toBeSaveVariant.conditions[toBeSaveVariant.tab].type" required>
                                <div ng-class="{'has-error' : hasError('condition')}">
                                    <wem-condition ref="toBeSaveVariant.conditions[toBeSaveVariant.tab]"
                                                   types="conditionTypes"
                                                   form="personalizedPage"
                                                   disable-boolean="false"
                                                   label-new="'condition.new'"
                                                   display-count="true"
                                                   disable-edition="toBeSaveVariant.disableEdition"></wem-condition>
                                </div>
                            </fieldset>
                        </div>
                    </div>
                </form>
            </div>
        </div>
        <template:module path="*" nodeTypes="${requestScope[constraints]}" />
    </c:when>
    <c:otherwise>
        <div style="color: red">
            <fmt:message key="wem.error.apacheUnomi"/>
        </div>
    </c:otherwise>
</c:choose>