<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContextreste" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>


<jsp:include page="../../commons/adminBaseImports.ui-bootstrap.jsp"/>

<template:addResources type="javascript"
                       resources="
                       marketing-factory/builds/wemPersonaPanelApp.js"/>

<template:addResources type="css" resources="marketing-factory/wem-persona-panel.css"/>

<div ng-app="wemPersonaPanelApp" class="wemPersonaPanelApp">
    <div ng-controller="PersonaPanelController as personaPanelCtrl">
        <uib-tabset role="tablist">
            <uib-tab heading="<fmt:message key="jnt_template.personas.tab.perso"/>" classes="tst-personalization-link">
                <header class="wem-page-head">
                    <label><fmt:message key="jnt_template.personas.title"/> :</label>
                    <select class="form-control"
                            ng-options="persona.itemId as persona.displayName for persona in personaPanelCtrl.personas.list"
                            ng-model="personaPanelCtrl.selectedPersona"
                            ng-change="personaPanelCtrl.personaSelected()">
                    </select>
                    <button class="btn btn-default" ng-click="personaPanelCtrl.resetPersona()" ng-show="personaPanelCtrl.hasOverridePersona()">
                        <i class="material-icons">restore</i>
                    </button>
                </header>

                <div class="baseSetCard perso-preview-card light-grey-bg" style="height: 88%">
                    <div class="box-3-text-container clearfix">
                        <form name="personaPanelCtrl.mapping" ng-submit="personaPanelCtrl.updatePersonaOverride()" novalidate="novalidate">
                            <div class="row">
                                <div ng-if="personaPanelCtrl.selectedPersona != 'none'">
                                    <div class="formmapcatsep">
                                        <fieldset>
                                            <div class="box-3-title-container">
                                                <legend>
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.togglableClick('segments')">
                                                        <i class="material-icons">{{ personaPanelCtrl.togglable.segments ? 'arrow_drop_up' : 'arrow_drop_down' }}</i>
                                                    </a>
                                                    <fmt:message key="jnt_template.personas.segments"/>
                                                </legend>
                                            </div>

                                            <div class="card-content-container" ng-show="personaPanelCtrl.togglable.segments">
                                                <div class="form-group col-md-12" ng-repeat="segmentValue in personaPanelCtrl.profileSegments" ng-class="{ filterTarget: personaPanelCtrl.isFilterOnTarget('profile.segments', segmentValue) }">
                                                    <input type="text" value="{{ personaPanelCtrl.getSegmentName(segmentValue) }}" disabled>
                                                    <a class="btn btn-default removeProp" ng-click="personaPanelCtrl.removeSegment(segmentValue)">
                                                        <i class="material-icons">remove_circle_outline</i>
                                                    </a>
                                                </div>

                                                <div class="form-group col-md-12" ng-show="personaPanelCtrl.propertiesHandler.addSegment">
                                                    <select ng-model="personaPanelCtrl.propertiesHandler.segmentsToAdd" class="form-control segment"
                                                            ng-options="segment as segment.name for segment in personaPanelCtrl.allSegments | orderBy: 'name' | filter:personaPanelCtrl.filterAvailableSegments"
                                                            multiple></select>
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.addSegments()"><i class="material-icons">check_circle</i></a>
                                                </div>

                                                <div ng-show="!personaPanelCtrl.propertiesHandler.addSegment">
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.propertiesHandler.addSegment = true"><i class="material-icons">add_circle</i></a>
                                                </div>
                                            </div>
                                        </fieldset>
                                    </div>

                                    <div class="formmapcatsep">
                                        <fieldset>
                                            <div class="box-3-title-container">
                                                <legend>
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.togglableClick('interests')">
                                                        <i class="material-icons">{{ personaPanelCtrl.togglable.interests ? 'arrow_drop_up' : 'arrow_drop_down' }}</i>
                                                    </a>
                                                    <fmt:message key="jnt_template.personas.interests"/>
                                                </legend>
                                            </div>

                                            <div class="card-content-container" ng-show="personaPanelCtrl.togglable.interests">
                                                <div class="form-group col-md-12" ng-repeat="(name, value) in personaPanelCtrl.profileProperties.interests">
                                                    <wem-foldable-input model="personaPanelCtrl.profileProperties.interests[name]" label="{{ name }}" type="number"></wem-foldable-input>
                                                    <a class="btn btn-default removeProp" ng-click="personaPanelCtrl.removeProp(name, 'interest')">
                                                        <i class="material-icons">remove_circle_outline</i>
                                                    </a>
                                                </div>

                                                <div class="form-group col-md-12" ng-show="personaPanelCtrl.propertiesHandler.addInterest">
                                                    <wem-foldable-input model="personaPanelCtrl.propertiesHandler.interestToAdd" label="name" type="text"></wem-foldable-input>
                                                    <wem-foldable-input model="personaPanelCtrl.propertiesHandler.interestToAddValue" label="value" type="number"></wem-foldable-input>
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.addInterest()">
                                                        <i class="material-icons">check_circle</i>
                                                    </a>
                                                </div>

                                                <div ng-show="!personaPanelCtrl.propertiesHandler.addInterest">
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.propertiesHandler.addInterest = true"><i class="material-icons">add_circle</i></a>
                                                </div>
                                            </div>
                                        </fieldset>
                                    </div>

                                    <div class="formmapcatsep">
                                        <fieldset>
                                            <div class="box-3-title-container">
                                                <legend>
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.togglableClick('pageViews')">
                                                        <i class="material-icons">{{ personaPanelCtrl.togglable.pageViews ? 'arrow_drop_up' : 'arrow_drop_down' }}</i>
                                                    </a>
                                                    <fmt:message key="condition.hasSeenNPagesCondition.numberOfPageViews"/>
                                                </legend>
                                            </div>

                                            <div class="card-content-container" ng-show="personaPanelCtrl.togglable.pageViews">
                                                <div class="form-group col-md-12">
                                                    <wem-foldable-input type="number" model="personaPanelCtrl.profileProperties.pageViewCount[wemScope]"></wem-foldable-input>
                                                </div>
                                            </div>
                                        </fieldset>
                                    </div>

                                    <div class="formmapcatsep">
                                        <fieldset ng-if="personaPanelCtrl.availableProfileProperties">
                                            <div class="box-3-title-container">
                                                <legend>
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.togglableClick('profile')">
                                                        <i class="material-icons">{{ personaPanelCtrl.togglable.profile ? 'arrow_drop_up' : 'arrow_drop_down' }}</i>
                                                    </a>
                                                    <fmt:message key="jnt_template.personas.all_properties"/>
                                                </legend>
                                            </div>

                                            <div class="card-content-container" ng-show="personaPanelCtrl.togglable.profile">
                                                <div class="form-group col-md-12" ng-repeat="name in personaPanelCtrl.filteredEditableProp('profile')"
                                                     ng-class="{ filterTarget: personaPanelCtrl.isFilterOnTarget('profile.properties.' + name),  'multivalue-persona-container': personaPanelCtrl.isMultivalue('profile', name) }">
                                                    <wem-foldable-input name="profile.{{ name }}" model="personaPanelCtrl.profileProperties[name]" label-key="profilesProperty.{{ name }}"
                                                                        label="{{ personaPanelCtrl.getPropertyName('profile', name) }}" type="{{ personaPanelCtrl.getPropertyInputType(name, 'profile') }}"
                                                                        ng-if="!personaPanelCtrl.choiceListValues.profile[name]" multivalued="personaPanelCtrl.isMultivalue('profile', name)"></wem-foldable-input>
                                                    <div class="group" ng-if="personaPanelCtrl.choiceListValues.profile[name]">
                                                        <select name="profile.{{ name }}"
                                                                ng-model="personaPanelCtrl.profilesProperty[name]"
                                                                ng-options="value as value for value in personaPanelCtrl.choiceListValues.profile[name]"
                                                                ng-change="personaPanelCtrl.updatePersonaOverride()"
                                                        >
                                                        </select>
                                                        <label class="foldedLabel" message-key="profileProperties.{{ name }}"></label>
                                                    </div>
                                                    <a class="btn btn-default removeProp" ng-click="personaPanelCtrl.removeProp(name, 'profile')">
                                                        <i class="material-icons">remove_circle_outline</i>
                                                    </a>
                                                </div>

                                                <div class="form-group col-md-12" ng-show="personaPanelCtrl.propertiesHandler.addProfileProperties">
                                                    <select class="form-control"
                                                            ng-model="personaPanelCtrl.propertiesHandler.profilePropertyToAdd"
                                                            ng-options="property.metadata.name for property in personaPanelCtrl.availableProfileProperties | filter:personaPanelCtrl.filterAvailableProps | orderBy: 'metadata.name'"
                                                            ng-change="personaPanelCtrl.addProfileProp()"></select>
                                                </div>

                                                <div ng-show="!personaPanelCtrl.propertiesHandler.addProfileProperties">
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.propertiesHandler.addProfileProperties = true">
                                                        <i class="material-icons">add_circle</i>
                                                    </a>
                                                </div>
                                            </div>
                                        </fieldset>
                                    </div>

                                    <div class="formmapcatsep">
                                        <fieldset ng-if="personaPanelCtrl.availableSessionProperties">
                                            <div class="box-3-title-container">
                                                <legend>
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.togglableClick('session')">
                                                        <i class="material-icons">{{ personaPanelCtrl.togglable.session ? 'arrow_drop_up' : 'arrow_drop_down' }}</i>
                                                    </a>
                                                    <fmt:message key="jnt_template.personas.session_properties"/>
                                                </legend>
                                            </div>

                                            <div class="card-content-container" ng-show="personaPanelCtrl.togglable.session">
                                                <div class="form-group col-md-12" ng-repeat="name in personaPanelCtrl.filteredEditableProp('session')"
                                                     ng-class="{ filterTarget: personaPanelCtrl.isFilterOnTarget('profile.properties.' + name), 'multivalue-persona-container': personaPanelCtrl.isMultivalue('session', name) }"
                                                     ng-switch on="name">
                                                    <wem-foldable-input name="session.{{name}}" model="personaPanelCtrl.sessionProperties[name]" label-key="sessionProperties.{{name}}"
                                                                        label="{{ personaPanelCtrl.getPropertyName('session', name) }}" type="{{ personaPanelCtrl.getPropertyInputType(name, 'session') }}"
                                                                        ng-if="!personaPanelCtrl.choiceListValues.session[name]" multivalued="personaPanelCtrl.isMultivalue('session', name)"></wem-foldable-input>
                                                    <div class="group" ng-if="personaPanelCtrl.choiceListValues.session[name]">
                                                        <select name="session.{{ name }}"
                                                                ng-model="personaPanelCtrl.sessionProperties[name]"
                                                                ng-options="value as value for value in personaPanelCtrl.choiceListValues.session[name]"
                                                                ng-change="personaPanelCtrl.updatePersonaOverride()"
                                                        >
                                                        </select>
                                                        <label class="foldedLabel" message-key="sessionProperties.{{ name }}"></label>
                                                    </div>
                                                    <a class="btn btn-default removeProp" ng-click="personaPanelCtrl.removeProp(name, 'session')">
                                                        <i class="material-icons">remove_circle_outline</i>
                                                    </a>
                                                </div>

                                                <div class="form-group col-md-12" ng-show="personaPanelCtrl.propertiesHandler.addSessionProperties">
                                                    <select class="form-control"
                                                            ng-model="personaPanelCtrl.propertiesHandler.sessionPropertyToAdd"
                                                            ng-options="property.metadata.name for property in personaPanelCtrl.availableSessionProperties | orderBy: 'metadata.name' | filter:personaPanelCtrl.filterAvailableProps"
                                                            ng-change="personaPanelCtrl.addSessionProp()"></select>
                                                </div>


                                                <div ng-show="!personaPanelCtrl.propertiesHandler.addSessionProperties">
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.propertiesHandler.addSessionProperties = true">
                                                        <i class="material-icons">add_circle</i>
                                                    </a>
                                                </div>
                                            </div>
                                        </fieldset>
                                    </div>
                                    <div class="formmapcatsep">
                                        <fieldset>
                                            <div class="box-3-title-container">
                                                <legend>
                                                    <a class="btn btn-default" ng-click="or('scoringPlan')">
                                                        <i class="material-icons">{{ personaPanelCtrl.togglable.scoringPlan ? 'arrow_drop_up' : 'arrow_drop_down' }}</i>
                                                    </a>
                                                    <fmt:message key="jnt_template.personas.scoringPlan"/>
                                                </legend>
                                            </div>

                                            <div class="card-content-container" ng-show="personaPanelCtrl.togglable.scoringPlan">
                                                <div class="form-group col-md-12" ng-repeat="scoringPlan in personaPanelCtrl.filteredEditableScoring()"
                                                     ng-class="{filterTarget: personaPanelCtrl.isFilterOnTarget('scoringPlan.' + id)}" ng-switch on="id">
                                                    <wem-foldable-input name="{{ scoringPlan }}" model="personaPanelCtrl.scoringPlans[scoringPlan]"
                                                                        label="{{ personaPanelCtrl.availableScoringPlansIndexed[scoringPlan].name }}" type="number"></wem-foldable-input>
                                                    <a class="btn btn-default removeProp" ng-click="personaPanelCtrl.removeScoringPlan(scoringPlan)">
                                                        <i class="material-icons">remove_circle_outline</i>
                                                    </a>
                                                </div>
                                                <div class="form-group col-md-12" ng-show="personaPanelCtrl.propertiesHandler.addScoringPlans">
                                                    <select class="form-control"
                                                            ng-model="personaPanelCtrl.propertiesHandler.scoringPlanToAdd"
                                                            ng-options="scoring.name for scoring in personaPanelCtrl.availableScoringPlans | orderBy: 'name' | filter:personaPanelCtrl.filterAvailableScoringPlans"
                                                            ng-change="personaPanelCtrl.addScoringPlan()"></select>
                                                </div>
                                                <div ng-show="!personaPanelCtrl.propertiesHandler.addScoringPlan">
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.propertiesHandler.addScoringPlans = true">
                                                        <i class="material-icons">add_circle</i>
                                                    </a>
                                                </div>
                                            </div>
                                        </fieldset>
                                    </div>
                                    <div class="formmapcatsep" style="margin-bottom: 75px;">
                                        <fieldset>
                                            <div class="box-3-title-container">
                                                <legend>
                                                    <a class="btn btn-default" ng-click="personaPanelCtrl.togglableClick('location')">
                                                        <i class="material-icons">{{ personaPanelCtrl.togglable.location ? 'arrow_drop_up' : 'arrow_drop_down' }}</i>
                                                    </a>
                                                    <fmt:message key="jnt_template.personas.locations"/>
                                                </legend>
                                            </div>

                                            <div class="card-content-container" ng-show="personaPanelCtrl.togglable.location">
                                                <div class="form-group col-md-12" ng-class="{ filterTarget: personaPanelCtrl.isFilterOnTarget('session.sessionCountryName') }">
                                                    <span>{{ personaPanelCtrl.getPropertyResourceName("session", "sessionCountryName") }}</span>
                                                    <div ng-show="personaPanelCtrl.locationHandler.countryLoaded">
                                                        <select ng-model="personaPanelCtrl.sessionProperties['sessionCountryName']"
                                                                class="form-control"
                                                                ng-options="country.name as country.name for country in personaPanelCtrl.countries"
                                                                required="true"
                                                                ng-change="personaPanelCtrl.locationEdited('sessionCountryName')">
                                                        </select>
                                                        <div class="flag flag-{{ personaPanelCtrl.sessionProperties.sessionCountryCode.toLowerCase() }}" ng-if="personaPanelCtrl.sessionProperties['sessionCountryName']"></div>
                                                    </div>
                                                    <svg class="loadingSpinnerPersona" height="50" width="50" ng-show="!personaPanelCtrl.locationHandler.countryLoaded">
                                                        <circle class="loadingSpinnerPath" cx="25" cy="25" r="20" fill="none"
                                                                stroke-width="6" stroke-miterlimit="10"></circle>
                                                    </svg>
                                                </div>

                                                <div class="form-group col-md-12" ng-class="{ filterTarget: personaPanelCtrl.isFilterOnTarget('session.sessionAdminSubDiv1') }"
                                                     ng-show="personaPanelCtrl.adm1List"
                                                     ng-if="personaPanelCtrl.sessionProperties['sessionCountryName']">
                                                    <span>{{ personaPanelCtrl.getPropertyResourceName("session", "sessionAdminSubDiv1") }}</span>
                                                    <div ng-show="personaPanelCtrl.locationHandler.adm1Loaded">
                                                        <select ng-model="personaPanelCtrl.sessionProperties.sessionAdminSubDiv1"
                                                                class="form-control"
                                                                ng-options="adm1.itemId as adm1.name for adm1 in personaPanelCtrl.adm1List"
                                                                required="true"
                                                                ng-change="personaPanelCtrl.locationEdited('sessionAdminSubDiv1')">
                                                        </select>
                                                    </div>
                                                    <div  ng-show="!personaPanelCtrl.locationHandler.adm1Loaded">
                                                        <svg class="loadingSpinnerPersona" height="50" width="50">
                                                            <circle class="loadingSpinnerPath" cx="25" cy="25" r="20" fill="none"
                                                                    stroke-width="6" stroke-miterlimit="10"></circle>
                                                        </svg>
                                                    </div>
                                                </div>

                                                <div class="form-group col-md-12" ng-class="{ filterTarget: personaPanelCtrl.isFilterOnTarget('session.sessionAdminSubDiv2') }"
                                                     ng-show="personaPanelCtrl.adm2List && personaPanelCtrl.sessionProperties['sessionCountryName']">
                                                    <span>{{ personaPanelCtrl.getPropertyResourceName("session","sessionAdminSubDiv2") }}</span>
                                                    <div ng-show="personaPanelCtrl.locationHandler.adm2Loaded">
                                                        <select ng-model="personaPanelCtrl.sessionProperties.sessionAdminSubDiv2"
                                                                class="form-control"
                                                                ng-options="adm2.itemId as adm2.name for adm2 in personaPanelCtrl.adm2List"
                                                                required="true"
                                                                ng-change="personaPanelCtrl.locationEdited('sessionAdminSubDiv2')">
                                                        </select>
                                                    </div>
                                                    <svg class="loadingSpinnerPersona" height="50" width="50"
                                                         ng-show="!personaPanelCtrl.locationHandler.adm2Loaded">
                                                        <circle class="loadingSpinnerPath" cx="25" cy="25" r="20" fill="none"
                                                                stroke-width="6" stroke-miterlimit="10"></circle>
                                                    </svg>
                                                </div>

                                                <div class="form-group col-md-12" ng-class="{ filterTarget: personaPanelCtrl.isFilterOnTarget('session.' + personaPanelCtrl.sessionCity) }"
                                                     ng-show="personaPanelCtrl.cities.length > 0 && personaPanelCtrl.sessionProperties['sessionCountryName']">
                                                    <span>{{personaPanelCtrl.getPropertyResourceName("session","sessionCity")}}</span>
                                                    <div ng-show="personaPanelCtrl.locationHandler.cityLoaded">
                                                        <select ng-model="personaPanelCtrl.sessionProperties.sessionCityId"
                                                                class="form-control"
                                                                ng-options="city.itemId as city.name for city in personaPanelCtrl.cities"
                                                                required="true"
                                                                ng-change="personaPanelCtrl.locationEdited('sessionCityId')">
                                                        </select>
                                                    </div>
                                                    <svg class="loadingSpinnerPersona" height="50" width="50"
                                                         ng-show="!personaPanelCtrl.locationHandler.cityLoaded">
                                                        <circle class="loadingSpinnerPath" cx="25" cy="25" r="20" fill="none"
                                                                stroke-width="6" stroke-miterlimit="10"></circle>
                                                    </svg>
                                                </div>

                                                <div>
                                                    <ui-gmap-google-map
                                                            center="personaPanelCtrl.map.center"
                                                            zoom="personaPanelCtrl.map.zoom"
                                                            control="personaPanelCtrl.map.control"
                                                            options="personaPanelCtrl.map.options"
                                                            pan="true">
                                                        <ui-gmap-marker coords="personaPanelCtrl.marker.coords"
                                                                        options="personaPanelCtrl.marker.options"
                                                                        events="personaPanelCtrl.marker.events"
                                                                        idkey="personaPanelCtrl.marker.id">
                                                        </ui-gmap-marker>
                                                    </ui-gmap-google-map>
                                                </div>
                                            </div>
                                        </fieldset>
                                    </div>
                                    <input type="submit"
                                           style="position: absolute; left: -9999px; width: 1px; height: 1px;"
                                           tabindex="-1" />
                                </div>
                                <div ng-if="personaPanelCtrl.selectedPersona == 'none'">
                                    <div>
                                        <fieldset>
                                            <div class="box-3-title-container">
                                                <legend class="warnMessage">
                                                    <fmt:message key="persona.panel.please.select.to.edit"/>
                                                </legend>
                                            </div>
                                        </fieldset>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </uib-tab>

            <uib-tab heading="<fmt:message key="jnt_template.personas.tab.optitests"/>" classes="tst-optimization-link">
                <div class="baseSetCard light-grey-bg" style="height: 88%">
                    <div class="box-3-text-container clearfix" ng-if="personaPanelCtrl.pageVariants">
                        <div class="row">
                            <div>
                                <div class="formmapcatsep">
                                    <fieldset>
                                        <div class="box-3-title-container">
                                            <legend>
                                                <a class="btn btn-default" ng-click="personaPanelCtrl.togglableClick('optimizationPage')">
                                                    <i class="material-icons">{{ personaPanelCtrl.togglable.optimizationPage ? 'arrow_drop_up' : 'arrow_drop_down' }}</i>
                                                </a>
                                                <fmt:message key="jnt_template.personas.optipage"/>
                                            </legend>
                                        </div>

                                        <div ng-show="personaPanelCtrl.togglable.optimizationPage">
                                            <div class="form-group col-md-12">
                                                <select ng-model="personaPanelCtrl.variantToApply" class="form-control segment"
                                                        ng-options="pageVariant.name as pageVariant.title for pageVariant in personaPanelCtrl.pageVariants"
                                                        ng-change="personaPanelCtrl.reloadWithSelectedVariant(personaPanelCtrl.variantToApply)"></select>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="box-3-text-container clearfix" ng-if="personaPanelCtrl.areas">
                        <div class="row">
                            <div>
                                <div class="formmapcatsep">
                                    <fieldset>
                                        <div class="box-3-title-container">
                                            <legend>
                                                <a class="btn btn-default" ng-click="personaPanelCtrl.togglableClick('optimizationContent')">
                                                    <i class="material-icons">{{ personaPanelCtrl.togglable.optimizationContent ? 'arrow_drop_up' : 'arrow_drop_down' }}</i>
                                                </a>
                                                <fmt:message key="jnt_template.personas.opticontent"/>
                                            </legend>
                                        </div>

                                        <div ng-show="personaPanelCtrl.togglable.optimizationContent">
                                            <div class="form-group col-md-12" ng-repeat="(key, value) in personaPanelCtrl.areas">
                                                <label class="foldedLabel">{{value.name}}</label>
                                                <select ng-model="personaPanelCtrl.contentVariantToApply[key]" class="form-control segment"
                                                        ng-options="contentVariant.content as contentVariant.name for contentVariant in value.variants"
                                                        ng-change="personaPanelCtrl.reloadWithSelectedContentVariant(key)"></select>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div ng-if="!personaPanelCtrl.pageVariants && !personaPanelCtrl.areas">
                        <div>
                            <fieldset>
                                <div class="box-3-title-container">
                                    <legend class="warnMessage">
                                        <fmt:message key="persona.panel.opti.notFound"/>
                                    </legend>
                                </div>
                            </fieldset>
                        </div>
                    </div>
                </div>
            </uib-tab>
        </uib-tabset>
    </div>
</div>